#include <windows.h>
#include <stdio.h>
#include <string.h>


unsigned int file_count;    // counted file store in file_count
unsigned int folder_count;  // counted folder store in file_count


void filecount(char *path, char *filter)
{
	char temp_path[MAX_PATH] = {0}; // temporary path
	WIN32_FIND_DATA fd;
	HANDLE hFind;

	// check path and filter to not empty, if there are return
	if ( !*path || !*filter )
		return;

	strcpy(temp_path, path);

	// check last charackter to be '\'
	if ( strncmp( (temp_path + strlen(temp_path)) - 1, "\\", 1) )
		strcat(temp_path, "\\");

	strcat(temp_path, filter);

	hFind = FindFirstFile(temp_path, &fd);

	if ( hFind  )
	{
		do
		{
			if ( strcmp(fd.cFileName, ".") != 0 && strcmp(fd.cFileName, "..") != 0 )
			{
				 // if directory count it and go search inside directory
				if ((fd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
				{
					// increase folder_count for each folder
					folder_count++;

					strcpy(temp_path, path);

					// check last charackter to be '\'
					if ( strncmp( (temp_path + strlen(temp_path)) - 1, "\\", 1) )
						strcat(temp_path, "\\");;

					strcat(temp_path, fd.cFileName);

					filecount(temp_path, filter);
				}
				else
				{
					// increase folder_count for each file
					file_count++;
				}
			}

		}while(FindNextFile(hFind, &fd));

		FindClose(hFind);
	}	
}

int main()
{
	char ph[MAX_PATH] = {0};
	char fil[10] = {0};

	printf("enter a path : ");
	gets(ph);

	printf("enter filter : ");
	gets(fil);

	filecount(ph, fil);

	printf("file : %d\nfolder : %d\n", file_count, folder_count);

	getc(stdin);

	return 0;
}
